(*
   This file is part of The Construct - a graphical user interface
   builder for ML::AbstractUI written in Standard ML.

   Copyright (C) 1999 ANOQ of the Sun (alias Johnny Andersen)

   E-mail: anoq@HardcoreProcessing.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   If you are interested in a warranty or commercial support for this
   software, contact Hardcore Processing <sales@HardcoreProcessing.com>
   for more information.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)

(*require "$.gtwinnt.dgshorthand";*)
(*require "$.gtwinnt.dgpcommon";*)
(*require "$.mlabstractuiwinnt.pnotifiers";*)
(*require "$.mlabstractuiwinnt.winregistered";*)

functor FOperator() =
  struct
    fun createGraph masterNode =
          let
            open DGShorthand

            val masterCh = masterNode +: "Children"
            val window0 = Reg.createA "Window"
            val _ = masterCh ~+ window0
            val tmpProtNode = window0 +: "OnPointerDown"
            val protocol1 = DGPPointerButtonNotify.p tmpProtNode
            val tmpProtNode = window0 +: "Text"
            val protocol2 = DGPString.p tmpProtNode
            val _ = PString.write protocol2 "Operator"
            val tmpProtNode = window0 +: "Visible"
            val protocol3 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol3 true
            val tmpProtNode = window0 +: "PosY"
            val protocol4 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol4 22
            val tmpProtNode = window0 +: "PosX"
            val protocol5 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol5 0
            val tmpProtNode = window0 +: "SizeY"
            val protocol6 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol6 54
            val tmpProtNode = window0 +: "SizeX"
            val protocol7 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol7 275
            
            val children8 = window0 +: "Children"
            
            val control9 = Reg.createA "TextLabel"
            val _ = children8 ~+ control9
            val tmpProtNode = control9 +: "OnPointerDown"
            val protocol10 = DGPPointerButtonNotify.p tmpProtNode
            val tmpProtNode = control9 +: "Visible"
            val protocol11 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol11 true
            val tmpProtNode = control9 +: "PosY"
            val protocol12 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol12 36
            val tmpProtNode = control9 +: "PosX"
            val protocol13 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol13 0
            val tmpProtNode = control9 +: "SizeY"
            val protocol14 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol14 18
            val tmpProtNode = control9 +: "SizeX"
            val protocol15 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol15 275
            val tmpProtNode = control9 +: "Text"
            val messageString = DGPString.p tmpProtNode
            val _ = PString.write messageString ""
            
            val control17 = Reg.createA "Button"
            val _ = children8 ~+ control17
            val tmpProtNode = control17 +: "OnPointerDown"
            val protocol18 = DGPPointerButtonNotify.p tmpProtNode
            val tmpProtNode = control17 +: "Visible"
            val protocol19 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol19 true
            val tmpProtNode = control17 +: "PosY"
            val protocol20 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol20 0
            val tmpProtNode = control17 +: "PosX"
            val protocol21 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol21 0
            val tmpProtNode = control17 +: "SizeY"
            val protocol22 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol22 18
            val tmpProtNode = control17 +: "SizeX"
            val protocol23 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol23 75
            val tmpProtNode = control17 +: "OnAction"
            val onLoad = DGPNotify.p tmpProtNode
            val tmpProtNode = control17 +: "Text"
            val protocol24 = DGPString.p tmpProtNode
            val _ = PString.write protocol24 "Load"
            
            val control26 = Reg.createA "Button"
            val _ = children8 ~+ control26
            val tmpProtNode = control26 +: "OnPointerDown"
            val protocol27 = DGPPointerButtonNotify.p tmpProtNode
            val tmpProtNode = control26 +: "Visible"
            val protocol28 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol28 true
            val tmpProtNode = control26 +: "PosY"
            val protocol29 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol29 18
            val tmpProtNode = control26 +: "PosX"
            val protocol30 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol30 0
            val tmpProtNode = control26 +: "SizeY"
            val protocol31 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol31 18
            val tmpProtNode = control26 +: "SizeX"
            val protocol32 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol32 75
            val tmpProtNode = control26 +: "OnAction"
            val onSave = DGPNotify.p tmpProtNode
            val tmpProtNode = control26 +: "Text"
            val protocol33 = DGPString.p tmpProtNode
            val _ = PString.write protocol33 "Save"
            
            val control35 = Reg.createA "TextField"
            val _ = children8 ~+ control35
            val tmpProtNode = control35 +: "OnPointerDown"
            val protocol36 = DGPPointerButtonNotify.p tmpProtNode
            val tmpProtNode = control35 +: "Visible"
            val protocol37 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol37 true
            val tmpProtNode = control35 +: "PosY"
            val protocol38 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol38 0
            val tmpProtNode = control35 +: "PosX"
            val protocol39 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol39 75
            val tmpProtNode = control35 +: "SizeY"
            val protocol40 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol40 18
            val tmpProtNode = control35 +: "SizeX"
            val protocol41 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol41 200
            val tmpProtNode = control35 +: "HasFocus"
            val protocol42 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol42 false
            val tmpProtNode = control35 +: "EditableText"
            val loadFileName = DGPString.p tmpProtNode
            val _ = PString.write loadFileName ""
            
            val control44 = Reg.createA "TextField"
            val _ = children8 ~+ control44
            val tmpProtNode = control44 +: "OnPointerDown"
            val protocol45 = DGPPointerButtonNotify.p tmpProtNode
            val tmpProtNode = control44 +: "Visible"
            val protocol46 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol46 true
            val tmpProtNode = control44 +: "PosY"
            val protocol47 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol47 18
            val tmpProtNode = control44 +: "PosX"
            val protocol48 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol48 75
            val tmpProtNode = control44 +: "SizeY"
            val protocol49 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol49 18
            val tmpProtNode = control44 +: "SizeX"
            val protocol50 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol50 200
            val tmpProtNode = control44 +: "HasFocus"
            val protocol51 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol51 true
            val tmpProtNode = control44 +: "EditableText"
            val saveFileName = DGPString.p tmpProtNode
            val _ = PString.write saveFileName ""
            
          in
            {saveFileName = saveFileName,
             loadFileName = loadFileName,
             onSave = onSave,
             onLoad = onLoad,
             messageString = messageString}
          end
  end

structure Operator = FOperator()
