(*
   This file is part of The Construct - a graphical user interface
   builder for ML::AbstractUI written in Standard ML.

   Copyright (C) 1999 ANOQ of the Sun (alias Johnny Andersen)

   E-mail: anoq@HardcoreProcessing.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   If you are interested in a warranty or commercial support for this
   software, contact Hardcore Processing <sales@HardcoreProcessing.com>
   for more information.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)

(*require "$.mlabstractuiwinnt.winregistered";*)
(*require "$.gtwinnt.dgnodes";*)
(*require "$.gtwinnt.dgshorthand";*)
(*require "$.gtwinnt.dgpcommon";*)
(*require "$.mlabstractuiwinnt.pnotifiers";*)
(*require "protocolaccessor_sig";*)

functor FProtocolAccessor() :> PROTOCOL_ACCESSOR =
  struct
    fun createGraph masterNode =
          let
            open DGShorthand

            val masterCh = masterNode +: "Children"
            val protocolAccessor = Reg.createA "Window"
            val _ = masterCh ~+ protocolAccessor
            val tmpProtNode = protocolAccessor +: "OnPointerDown"
            val protocol0 = DGPPointerButtonNotify.p tmpProtNode
            val tmpProtNode = protocolAccessor +: "Text"
            val protocol1 = DGPString.p tmpProtNode
            val _ = PString.write protocol1 "Protocol Accessor"
            val tmpProtNode = protocolAccessor +: "Visible"
            val protocol2 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol2 true
            val tmpProtNode = protocolAccessor +: "PosY"
            val protocol3 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol3 151
            val tmpProtNode = protocolAccessor +: "PosX"
            val protocol4 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol4 513
            val tmpProtNode = protocolAccessor +: "SizeY"
            val protocol5 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol5 100
            val tmpProtNode = protocolAccessor +: "SizeX"
            val protocol6 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol6 500
            
            val children7 = protocolAccessor +: "Children"
            
            val control8 = Reg.createA "TextLabel"
            val _ = children7 ~+ control8
            val tmpProtNode = control8 +: "OnPointerDown"
            val protocol9 = DGPPointerButtonNotify.p tmpProtNode
            val tmpProtNode = control8 +: "Visible"
            val protocol10 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol10 true
            val tmpProtNode = control8 +: "PosY"
            val protocol11 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol11 0
            val tmpProtNode = control8 +: "PosX"
            val protocol12 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol12 200
            val tmpProtNode = control8 +: "SizeY"
            val protocol13 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol13 18
            val tmpProtNode = control8 +: "SizeX"
            val protocol14 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol14 300
            val tmpProtNode = control8 +: "Text"
            val protocol15 = DGPString.p tmpProtNode
            val _ = PString.write protocol15 "Protocols"
            
            val control17 = Reg.createA "TextLabel"
            val _ = children7 ~+ control17
            val tmpProtNode = control17 +: "OnPointerDown"
            val protocol18 = DGPPointerButtonNotify.p tmpProtNode
            val tmpProtNode = control17 +: "Visible"
            val protocol19 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol19 true
            val tmpProtNode = control17 +: "PosY"
            val protocol20 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol20 0
            val tmpProtNode = control17 +: "PosX"
            val protocol21 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol21 0
            val tmpProtNode = control17 +: "SizeY"
            val protocol22 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol22 18
            val tmpProtNode = control17 +: "SizeX"
            val protocol23 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol23 200
            val tmpProtNode = control17 +: "Text"
            val protocol24 = DGPString.p tmpProtNode
            val _ = PString.write protocol24 "Bindings"
            
          in
            {protocolAccessor = protocolAccessor}
          end
  end

structure ProtocolAccessor = FProtocolAccessor()
