(*
   This file is part of The Construct - a graphical user interface
   builder for ML::AbstractUI written in Standard ML.

   Copyright (C) 1999 ANOQ of the Sun (alias Johnny Andersen)

   E-mail: anoq@HardcoreProcessing.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   If you are interested in a warranty or commercial support for this
   software, contact Hardcore Processing <sales@HardcoreProcessing.com>
   for more information.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)

(*require "$.mlabstractuiwinnt.winregistered";*)
(*require "$.gtwinnt.dgnodes";*)
(*require "$.gtwinnt.dgshorthand";*)
(*require "$.gtwinnt.dgpcommon";*)
(*require "$.mlabstractuiwinnt.pnotifiers";*)
(*require "uicontrolpalette_sig";*)

functor FUIControlPalette() :> UI_CONTROL_PALETTE =
  struct
    fun createGraph masterNode =
          let
            open DGShorthand

            val masterCh = masterNode +: "Children"
            val controlPalette = Reg.createA "Window"
            val _ = masterCh ~+ controlPalette
            val tmpProtNode = controlPalette +: "OnPointerDown"
            val protocol0 = DGPPointerButtonNotify.p tmpProtNode
            val tmpProtNode = controlPalette +: "Text"
            val protocol1 = DGPString.p tmpProtNode
            val _ = PString.write protocol1 "UI Palette"
            val tmpProtNode = controlPalette +: "Visible"
            val protocol2 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol2 true
            val tmpProtNode = controlPalette +: "PosY"
            val protocol3 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol3 308
            val tmpProtNode = controlPalette +: "PosX"
            val protocol4 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol4 608
            val tmpProtNode = controlPalette +: "SizeY"
            val protocol5 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol5 100
            val tmpProtNode = controlPalette +: "SizeX"
            val protocol6 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol6 150
            
          in
            {controlPalette = controlPalette}
          end
  end

structure UIControlPalette = FUIControlPalette()
