(*
   This file is part of The Construct - a graphical user interface
   builder for ML::AbstractUI written in Standard ML.

   Copyright (C) 1999 ANOQ of the Sun (alias Johnny Andersen)

   E-mail: anoq@HardcoreProcessing.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   If you are interested in a warranty or commercial support for this
   software, contact Hardcore Processing <sales@HardcoreProcessing.com>
   for more information.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)

functor FCeX3DOrganizer() =
  struct
    fun createGraph masterNode =
          let
            open DGShorthand

            val masterCh = masterNode +: "Children"
            val window0 = Reg.createA "Window"
            val _ = masterCh ~+ window0
            val tmpProtNode = window0 +: "OnPointerDown"
            val protocol1 = DGPPointerButtonNotify.p tmpProtNode
            val tmpProtNode = window0 +: "Text"
            val protocol2 = DGPString.p tmpProtNode
            val _ = PString.write protocol2 "CeX3D Organizer"
            val tmpProtNode = window0 +: "Visible"
            val protocol3 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol3 true
            val tmpProtNode = window0 +: "PosY"
            val protocol4 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol4 84
            val tmpProtNode = window0 +: "PosX"
            val protocol5 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol5 540
            val tmpProtNode = window0 +: "SizeY"
            val protocol6 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol6 380
            val tmpProtNode = window0 +: "SizeX"
            val protocol7 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol7 400
            
            val children8 = window0 +: "Children"
            
            val control9 = Reg.createA "Button"
            val _ = children8 ~+ control9
            val tmpProtNode = control9 +: "OnPointerDown"
            val protocol10 = DGPPointerButtonNotify.p tmpProtNode
            val tmpProtNode = control9 +: "Visible"
            val protocol11 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol11 true
            val tmpProtNode = control9 +: "PosY"
            val protocol12 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol12 360
            val tmpProtNode = control9 +: "PosX"
            val protocol13 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol13 150
            val tmpProtNode = control9 +: "SizeY"
            val protocol14 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol14 18
            val tmpProtNode = control9 +: "SizeX"
            val protocol15 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol15 75
            val tmpProtNode = control9 +: "OnAction"
            val pasteAction = DGPNotify.p tmpProtNode
            val tmpProtNode = control9 +: "Text"
            val protocol16 = DGPString.p tmpProtNode
            val _ = PString.write protocol16 "Paste"
            
            val control18 = Reg.createA "Button"
            val _ = children8 ~+ control18
            val tmpProtNode = control18 +: "OnPointerDown"
            val protocol19 = DGPPointerButtonNotify.p tmpProtNode
            val tmpProtNode = control18 +: "Visible"
            val protocol20 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol20 true
            val tmpProtNode = control18 +: "PosY"
            val protocol21 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol21 360
            val tmpProtNode = control18 +: "PosX"
            val protocol22 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol22 75
            val tmpProtNode = control18 +: "SizeY"
            val protocol23 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol23 18
            val tmpProtNode = control18 +: "SizeX"
            val protocol24 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol24 75
            val tmpProtNode = control18 +: "OnAction"
            val copyAction = DGPNotify.p tmpProtNode
            val tmpProtNode = control18 +: "Text"
            val protocol25 = DGPString.p tmpProtNode
            val _ = PString.write protocol25 "Copy"
            
            val control27 = Reg.createA "Button"
            val _ = children8 ~+ control27
            val tmpProtNode = control27 +: "OnPointerDown"
            val protocol28 = DGPPointerButtonNotify.p tmpProtNode
            val tmpProtNode = control27 +: "Visible"
            val protocol29 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol29 true
            val tmpProtNode = control27 +: "PosY"
            val protocol30 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol30 360
            val tmpProtNode = control27 +: "PosX"
            val protocol31 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol31 0
            val tmpProtNode = control27 +: "SizeY"
            val protocol32 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol32 18
            val tmpProtNode = control27 +: "SizeX"
            val protocol33 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol33 75
            val tmpProtNode = control27 +: "OnAction"
            val cutAction = DGPNotify.p tmpProtNode
            val tmpProtNode = control27 +: "Text"
            val protocol34 = DGPString.p tmpProtNode
            val _ = PString.write protocol34 "Cut"
            
            val control36 = Reg.createA "TextLabel"
            val _ = children8 ~+ control36
            val tmpProtNode = control36 +: "OnPointerDown"
            val protocol37 = DGPPointerButtonNotify.p tmpProtNode
            val tmpProtNode = control36 +: "Visible"
            val protocol38 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol38 true
            val tmpProtNode = control36 +: "PosY"
            val protocol39 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol39 340
            val tmpProtNode = control36 +: "PosX"
            val protocol40 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol40 0
            val tmpProtNode = control36 +: "SizeY"
            val protocol41 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol41 18
            val tmpProtNode = control36 +: "SizeX"
            val protocol42 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol42 400
            val tmpProtNode = control36 +: "Text"
            val messageString = DGPString.p tmpProtNode
            val _ = PString.write messageString "Error messages will be shown here"
            
            val control44 = Reg.createA "TextLabel"
            val _ = children8 ~+ control44
            val tmpProtNode = control44 +: "OnPointerDown"
            val protocol45 = DGPPointerButtonNotify.p tmpProtNode
            val tmpProtNode = control44 +: "Visible"
            val protocol46 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol46 true
            val tmpProtNode = control44 +: "PosY"
            val protocol47 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol47 20
            val tmpProtNode = control44 +: "PosX"
            val protocol48 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol48 0
            val tmpProtNode = control44 +: "SizeY"
            val protocol49 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol49 18
            val tmpProtNode = control44 +: "SizeX"
            val protocol50 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol50 400
            val tmpProtNode = control44 +: "Text"
            val pathString = DGPString.p tmpProtNode
            val _ = PString.write pathString ""
            
            val control52 = Reg.createA "Button"
            val _ = children8 ~+ control52
            val tmpProtNode = control52 +: "OnPointerDown"
            val protocol53 = DGPPointerButtonNotify.p tmpProtNode
            val tmpProtNode = control52 +: "Visible"
            val protocol54 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol54 true
            val tmpProtNode = control52 +: "PosY"
            val protocol55 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol55 0
            val tmpProtNode = control52 +: "PosX"
            val protocol56 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol56 325
            val tmpProtNode = control52 +: "SizeY"
            val protocol57 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol57 18
            val tmpProtNode = control52 +: "SizeX"
            val protocol58 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol58 75
            val tmpProtNode = control52 +: "OnAction"
            val saveAction = DGPNotify.p tmpProtNode
            val tmpProtNode = control52 +: "Text"
            val protocol59 = DGPString.p tmpProtNode
            val _ = PString.write protocol59 "Save"
            
            val control61 = Reg.createA "TextField"
            val _ = children8 ~+ control61
            val tmpProtNode = control61 +: "OnPointerDown"
            val protocol62 = DGPPointerButtonNotify.p tmpProtNode
            val tmpProtNode = control61 +: "Visible"
            val protocol63 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol63 true
            val tmpProtNode = control61 +: "PosY"
            val protocol64 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol64 0
            val tmpProtNode = control61 +: "PosX"
            val protocol65 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol65 0
            val tmpProtNode = control61 +: "SizeY"
            val protocol66 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol66 18
            val tmpProtNode = control61 +: "SizeX"
            val protocol67 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol67 250
            val tmpProtNode = control61 +: "HasFocus"
            val protocol68 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol68 false
            val tmpProtNode = control61 +: "EditableText"
            val filenameString = DGPString.p tmpProtNode
            val _ = PString.write filenameString "<Enter filename here>"
            
            val control70 = Reg.createA "ListBox"
            val _ = children8 ~+ control70
            val tmpProtNode = control70 +: "OnPointerDown"
            val protocol71 = DGPPointerButtonNotify.p tmpProtNode
            val tmpProtNode = control70 +: "Visible"
            val protocol72 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol72 true
            val tmpProtNode = control70 +: "PosY"
            val protocol73 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol73 39
            val tmpProtNode = control70 +: "PosX"
            val protocol74 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol74 0
            val tmpProtNode = control70 +: "SizeY"
            val protocol75 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol75 300
            val tmpProtNode = control70 +: "SizeX"
            val protocol76 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol76 400
            val tmpProtNode = control70 +: "OnDoubleClick"
            val listboxDoubleClick = DGPPointerButtonNotify.p tmpProtNode
            val tmpProtNode = control70 +: "OnClick"
            val protocol79 = DGPPointerButtonNotify.p tmpProtNode
            val tmpProtNode = control70 +: "SelectableItems"
            val listboxSel = DGPItemSelections.p tmpProtNode
            val tmpProtNode = control70 +: "TextLines"
            val listboxLines = DGPStrings.p tmpProtNode
            
            val children80 = control70 +: "Children"
            
            val control81 = Reg.createA "Button"
            val _ = children8 ~+ control81
            val tmpProtNode = control81 +: "OnPointerDown"
            val protocol82 = DGPPointerButtonNotify.p tmpProtNode
            val tmpProtNode = control81 +: "Visible"
            val protocol83 = DGPBool.p tmpProtNode
            val _ = PBool.write protocol83 true
            val tmpProtNode = control81 +: "PosY"
            val protocol84 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol84 0
            val tmpProtNode = control81 +: "PosX"
            val protocol85 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol85 250
            val tmpProtNode = control81 +: "SizeY"
            val protocol86 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol86 18
            val tmpProtNode = control81 +: "SizeX"
            val protocol87 = DGPInt.p tmpProtNode
            val _ = PInt.write protocol87 75
            val tmpProtNode = control81 +: "OnAction"
            val loadAction = DGPNotify.p tmpProtNode
            val tmpProtNode = control81 +: "Text"
            val protocol88 = DGPString.p tmpProtNode
            val _ = PString.write protocol88 "Load"
            
          in
            {loadAction = loadAction,
             listboxLines = listboxLines,
             listboxSel = listboxSel,
             listboxDoubleClick = listboxDoubleClick,
             filenameString = filenameString,
             saveAction = saveAction,
             pathString = pathString,
             messageString = messageString,
             cutAction = cutAction,
             copyAction = copyAction,
             pasteAction = pasteAction}
          end
  end

structure CeX3DOrganizer = FCeX3DOrganizer()
